SoundManager = {}
SoundManager.objects = {}

SoundManager.available = ( function() 
	local files = love.filesystem.enumerate( "music/" )
	local new = {}
	for key, file in pairs( files ) do
		local prog = {}
		for word in file:gmatch( "[^%.]+" ) do
			table.insert( prog, word )
		end
		if #prog == 2 and prog[2] == "mp3" then
			new[file] = true
		end
	end
	return new
end )()

SoundManager.songObject = {
	__index = SoundManager.songObject;
	create = function( pSound )
		local self = {
			object = love.audio.newSource( "music/" .. pSound );
			getPlaying = function( self )
				return pSound
			end;
		}
		return setmetatable( self, SoundManager.songObject )
	end
}

SoundManager.new = function( pSound )
	if SoundManager.objects[ pSound ] then
		return SoundManager.objects[ pSound ] 
	elseif SoundManager.available[ pSound ] then
		SoundManager.objects[ pSound ] = SoundManager.songObject.create( pSound )
		return SoundManager.objects[ pSound ]
	end
end

SoundManager.getRandomSong = function()
	local files = love.filesystem.enumerate( "/music/" )
	return SoundManager.new( files[math.random( 1, #files)] )
end

